import type ConversationWebSocketConnection from "../protocol/connection";
import { AudioPlayer, CustomPlayerSpec } from "./interface";
import { ClientMessage } from "./protocol";
/**
 * Implementation of the audio control protocol over the conversation
 * websocket connection.
 */
export default class AudioSubprotocolImplementation implements AudioPlayer {
    private _conn;
    private _requests;
    private _nextReq;
    constructor(connection: ConversationWebSocketConnection, caps: string[]);
    get conversationId(): string;
    destroy(): void;
    handle(msg: ClientMessage): Promise<void>;
    private _req;
    private _simpleReq;
    checkCustomPlayer(spec: CustomPlayerSpec): Promise<boolean>;
    prepare(spec?: CustomPlayerSpec): Promise<void>;
    stop(): Promise<void>;
    pause(): Promise<void>;
    resume(): Promise<void>;
    playURLs(urls: string[]): Promise<void>;
    setVolume(volume: number): Promise<void>;
    adjustVolume(delta: number): Promise<void>;
    setMute(mute: boolean): Promise<void>;
    setVoiceInput(input: boolean): Promise<void>;
    setVoiceOutput(output: boolean): Promise<void>;
}
