import AssistantEngine from '../engine';
import { Message } from './protocol';
/**
 * Wrap access to the conversation history in the database.
 *
 * This object keeps a buffer of messages in memory, but also
 * allows scrollback to previous messages.
 */
export default class ConversationHistory {
    private readonly _conversationId;
    private readonly _db;
    private _cache;
    constructor(engine: AssistantEngine, conversationId: string);
    getCached(): Message[];
    init(): Promise<void>;
    addMessage(msg: Message): Promise<void>;
    scrollBack(fromMessageId: number, scrollBackSize?: number): Promise<Message[]>;
}
