import { DialogueExample, DialogueTurn } from "../dataset-tools/parsers";
import { ConversationRow, LocalTable } from "../engine/db";
export default class ConversationLogger {
    private readonly _conversationDB;
    private _conversationId;
    private _dialogueUniqueId;
    private _currentTurn;
    private _lastTurn;
    constructor(conversationDB: LocalTable<ConversationRow>, conversationId: string);
    dialogueFinished(): Promise<void>;
    turnFinished(): Promise<void>;
    voteLast(vote: 'up' | 'down'): Promise<void>;
    commentLast(comment: string): Promise<void>;
    updateLog(field: Exclude<keyof DialogueTurn, 'agent_timestamp' | 'user_timestamp'>, value: string): void;
    read(): AsyncIterableIterator<DialogueExample>;
}
