import type * as DB from '..';
import LocalTable from './local_table';
import SyncTable from './sync_table';
export interface DatabaseProxyConfig {
    baseUrl: string;
    accessToken?: string;
}
export declare class DatabaseProxy implements DB.AbstractDatabase {
    config: DatabaseProxyConfig;
    _config: DatabaseProxyConfig;
    constructor(config: DatabaseProxyConfig);
    ensureSchema(): Promise<void>;
    getLocalTable<T extends keyof DB.LocalTables>(name: T): LocalTable<DB.LocalTables[T]>;
    getSyncTable<T extends keyof DB.SyncTables>(name: T): SyncTable<DB.SyncTables[T]>;
}
