import type { SearchParams } from '..';
export default class LocalTable<RowType> {
    name: string;
    private _baseUrl;
    private _auth;
    constructor(name: string, baseUrl: string, accessToken: string | undefined);
    getAll(): Promise<RowType[]>;
    getOne(uniqueId: string): Promise<RowType | undefined>;
    getBy(field: keyof RowType, value: string): Promise<RowType[]>;
    search(search: SearchParams<RowType>): Promise<any>;
    insertOne(uniqueId: string, row: Omit<RowType, "uniqueId">): Promise<void>;
    deleteOne(uniqueId: string): Promise<void>;
}
