import * as sql from '.';
import type { SearchParams } from '..';
declare type Fields<RowType> = ReadonlyArray<Exclude<keyof RowType & string, "uniqueId">>;
export default class LocalTable<RowType> {
    name: string;
    private _db;
    private _fields;
    constructor(db: sql.SQLiteDatabase, name: string, fields: Fields<RowType>);
    getAll(): Promise<RowType[]>;
    getOne(uniqueId: string): Promise<RowType>;
    getBy(field: keyof RowType, value: string): Promise<RowType[]>;
    search(search: SearchParams<RowType>): Promise<any[]>;
    insertOne(uniqueId: string, row: Omit<RowType, "uniqueId">): Promise<void>;
    deleteOne(uniqueId: string): Promise<void>;
}
export {};
