import * as Tp from 'thingpedia';
import DeviceView from './device_view';
/**
 * An helper class over {@link DeviceView} that automatically maps
 * each device to a custom object (typically retrieved from {@link Tp.BaseDevice.queryInterface})
 */
export default class DeviceInterfaceMapper<T> {
    private _view;
    private _mapper;
    private _deviceAddedListener;
    private _deviceRemovedListener;
    private _objects;
    constructor(view: DeviceView, mapper: (device: Tp.BaseDevice) => T);
    values(): Iterable<T>;
    getById(uniqueId: string): T | undefined;
    private _onDeviceAdded;
    private _onDeviceRemoved;
    start(): void;
    stop(): void;
}
