import type $SentenceGenerator from "../sentence-generator/generator";
import * as $SentenceGeneratorTypes from "../sentence-generator/types";
import * as $I18n from "../i18n/index";
import { Ast } from 'thingtalk';
import ThingpediaLoader from './load-thingpedia';
export declare const forward_get_do_command: $SentenceGeneratorTypes.NonTerminal<Ast.ChainExpression>;
export declare const backward_get_do_command: $SentenceGeneratorTypes.NonTerminal<Ast.ChainExpression>;
export declare const forward_when_do_rule: $SentenceGeneratorTypes.NonTerminal<Ast.ChainExpression>;
export declare const backward_when_do_rule: $SentenceGeneratorTypes.NonTerminal<Ast.ChainExpression>;
export declare const when_get_stream: $SentenceGeneratorTypes.NonTerminal<Ast.ChainExpression>;
export declare const when_get_do_rule: $SentenceGeneratorTypes.NonTerminal<Ast.ChainExpression>;
export declare const timer_rule: $SentenceGeneratorTypes.NonTerminal<Ast.ChainExpression>;
export declare const generic_preamble_for_answer: $SentenceGeneratorTypes.NonTerminal<string>;
export declare const generic_preamble_for_action: $SentenceGeneratorTypes.NonTerminal<string>;
export declare const generic_verb_for_search: $SentenceGeneratorTypes.NonTerminal<string>;
export declare const imperative_verb_for_search: $SentenceGeneratorTypes.NonTerminal<string>;
export declare const generic_search_preamble: $SentenceGeneratorTypes.NonTerminal<string>;
export declare const generic_lookup_preamble: $SentenceGeneratorTypes.NonTerminal<string>;
export declare const generic_article: $SentenceGeneratorTypes.NonTerminal<string>;
export declare const search_command: $SentenceGeneratorTypes.NonTerminal<Ast.Expression>;
export declare const complete_question: $SentenceGeneratorTypes.NonTerminal<Ast.Expression>;
export declare const projection_question: $SentenceGeneratorTypes.NonTerminal<Ast.Expression>;
export declare const explicit_when_condition: $SentenceGeneratorTypes.NonTerminal<Ast.Expression>;
export declare const when_command: $SentenceGeneratorTypes.NonTerminal<Ast.Expression>;
export declare const monitor_command: $SentenceGeneratorTypes.NonTerminal<Ast.Expression>;
export declare const complete_action: $SentenceGeneratorTypes.NonTerminal<Ast.Expression>;
export declare const say_command: $SentenceGeneratorTypes.NonTerminal<Ast.Expression>;
/**
 * Load the templates in this file.
 *
 * This is an autogenerated method that will be called by the {@link SentenceGenerator}
 * when the templates are imported.
 */
export declare function $load($options: $SentenceGeneratorTypes.GrammarOptions, $locale: $I18n.LanguagePack, $grammar: $SentenceGenerator, $loader: ThingpediaLoader): Promise<void>;
