"use strict";
// -*- mode: js; indent-tabs-mode: nil; js-basic-offset: 4 -*-
//
// This file is part of Genie
//
// Copyright 2020 The Board of Trustees of the Leland Stanford Junior University
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Author: Giovanni Campagna <gcampagn@cs.stanford.edu>
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.$load = exports.related_question = void 0;
// Recommendation templates: the agent reads out or describe the top result from the search,
// optionally proposing an action to do on it
// A recommendation from the system is followed by:
// - yes (= "positive_recommendation_reply_pair")
// - some form of search refinement (= "negative_recommendation_reply_pair")
// - a question (= "recommendation_search_question_pair")
// - closing the dialogue (= "recommendation_cancel_pair")
const $runtime = __importStar(require("../../sentence-generator/runtime"));
const D = __importStar(require("../dialogue_acts"));
exports.related_question = "related_question";
/**
 * Load the templates in this file.
 *
 * This is an autogenerated method that will be called by the {@link SentenceGenerator}
 * when the templates are imported.
 */
async function $load($options, $locale, $grammar, $loader) {
    $grammar.declareSymbol("related_question");
    $grammar.addRule("related_question", [new $runtime.NonTerminal("ctx_for_related_question", "ctx", undefined), new $runtime.NonTerminal("search_command", "stmt", undefined)], $locale._("${ctx} ${stmt}"), ((ctx, stmt) => D.relatedQuestion(ctx, stmt)), undefined, { weight: (0.1) });
    $grammar.addRule("related_question", [new $runtime.NonTerminal("ctx_for_related_question", "ctx", undefined), new $runtime.NonTerminal("complete_question", "stmt", undefined)], $locale._("${ctx} ${stmt}"), ((ctx, stmt) => D.relatedQuestion(ctx, stmt)), undefined, {});
    $grammar.addRule("related_question", [new $runtime.NonTerminal("ctx_for_related_question", "ctx", undefined), new $runtime.NonTerminal("projection_question", "stmt", undefined)], $locale._("${ctx} ${stmt}"), ((ctx, stmt) => D.relatedQuestion(ctx, stmt)), undefined, { weight: (0.1) });
}
exports.$load = $load;
;
//# sourceMappingURL=related-questions.genie.out.js.map