import type $SentenceGenerator from "../sentence-generator/generator";
import * as $SentenceGeneratorTypes from "../sentence-generator/types";
import * as $I18n from "../i18n/index";
import { Ast } from 'thingtalk';
import * as C from './ast_manip';
import ThingpediaLoader from './load-thingpedia';
export declare const get_predicate_filter: $SentenceGeneratorTypes.NonTerminal<C.DomainIndependentFilterSlot>;
export declare const if_filter: $SentenceGeneratorTypes.NonTerminal<C.FilterSlot | C.DomainIndependentFilterSlot>;
export declare const edge_filter: $SentenceGeneratorTypes.NonTerminal<C.FilterSlot>;
export declare const either_filter: $SentenceGeneratorTypes.NonTerminal<C.FilterSlot>;
export declare const range: $SentenceGeneratorTypes.NonTerminal<[Ast.Value, Ast.Value]>;
export declare const range_filter: $SentenceGeneratorTypes.NonTerminal<C.FilterSlot>;
export declare const with_filter: $SentenceGeneratorTypes.NonTerminal<C.FilterSlot>;
export declare const range_with_filter: $SentenceGeneratorTypes.NonTerminal<C.FilterSlot>;
export declare const both_prefix: $SentenceGeneratorTypes.NonTerminal<string>;
export declare const nearby_filter: $SentenceGeneratorTypes.NonTerminal<C.DomainIndependentFilterSlot>;
export declare const whose_npp_filter: $SentenceGeneratorTypes.NonTerminal<C.FilterSlot>;
export declare const quality_filter: $SentenceGeneratorTypes.NonTerminal<C.DomainIndependentFilterSlot>;
export declare const within_filter: $SentenceGeneratorTypes.NonTerminal<({
    distance: Ast.Value;
    place: Ast.Value;
})>;
/**
 * Load the templates in this file.
 *
 * This is an autogenerated method that will be called by the {@link SentenceGenerator}
 * when the templates are imported.
 */
export declare function $load($options: $SentenceGeneratorTypes.GrammarOptions, $locale: $I18n.LanguagePack, $grammar: $SentenceGenerator, $loader: ThingpediaLoader): Promise<void>;
