import { Ast } from 'thingtalk';
import { ErrorMessage, ParamSlot, ExpressionWithCoreference } from './utils';
import { SlotBag } from './slot_bag';
import type ThingpediaLoader from './load-thingpedia';
export declare function replaceSlotBagPlaceholders(bag: SlotBag, names: Array<string | null>, args: Ast.Value[]): SlotBag | null;
export declare function replaceErrorMessagePlaceholders(msg: ErrorMessage, names: Array<string | null>, args: Ast.Value[]): ErrorMessage | null;
export declare function replacePlaceholdersWithConstants(ex: Ast.Example, names: Array<string | null>, args: Ast.Value[]): Ast.Expression | null;
export declare function replacePlaceholderWithTableOrStream(ex: Ast.Example, names: Array<string | null>, tableParamIdx: number, args: Array<Ast.Value | Ast.Expression>, tpLoader: ThingpediaLoader): Ast.ChainExpression | null;
export declare function replacePlaceholderWithCoreference(ex: Ast.Example, names: Array<string | null>, corefParamIdx: number, args: Array<Ast.Value | Ast.Expression | ParamSlot | string | undefined>): ExpressionWithCoreference | null;
