"use strict";
// -*- mode: js; indent-tabs-mode: nil; js-basic-offset: 4 -*-
//
// This file is part of Genie
//
// Copyright 2019-2020 The Board of Trustees of the Leland Stanford Junior University
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Author: Giovanni Campagna <gcampagn@cs.stanford.edu>
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.$load = exports.timer = void 0;
const $runtime = __importStar(require("../sentence-generator/runtime"));
const C = __importStar(require("./ast_manip"));
exports.timer = "timer";
/**
 * Load the templates in this file.
 *
 * This is an autogenerated method that will be called by the {@link SentenceGenerator}
 * when the templates are imported.
 */
async function $load($options, $locale, $grammar, $loader) {
    $grammar.declareSymbol("timer");
    $grammar.addRule("timer", [new $runtime.NonTerminal("at_time", "time", undefined)], $locale._("{every day|each day|daily|once a day} ${time}"), ((time) => C.makeRepeatingTimeTimer($loader, [time])), undefined, {});
    $grammar.addRule("timer", [new $runtime.NonTerminal("constant_Time", "time1", undefined), new $runtime.NonTerminal("constant_Time", "time2", undefined)], $locale._("{every day|each day|daily|twice a day} at ${time1} and ${time2}"), ((time1, time2) => C.makeRepeatingTimeTimer($loader, [time1, time2])), undefined, {});
    $grammar.addRule("timer", [new $runtime.NonTerminal("at_time", "time", undefined)], "${time}", ((time) => C.makeDateTimer($loader, C.makeDateWithDateTime(null, time))), undefined, {});
    $grammar.addRule("timer", [new $runtime.NonTerminal("constant_Date", "date", undefined)], $locale._("on ${date}"), ((date) => C.makeDateTimer($loader, date)), undefined, {});
    if (!$options.flags.turking) {
        $grammar.addRule("timer", [new $runtime.NonTerminal("unit_Measure_ms", "unit", undefined)], $locale._("{once {each|every|per|a}|each|every} ${unit}"), ((unit) => C.makeIntervalTimer($loader, unit)), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("constant_Number", "freq", undefined), new $runtime.NonTerminal("unit_Measure_ms", "unit", undefined)], $locale._("${freq} times {each|every|per|a} ${unit}"), ((freq, unit) => C.makeFrequencyTimer($loader, freq, unit)), undefined, {});
    }
}
exports.$load = $load;
;
//# sourceMappingURL=timers.genie.out.js.map