import { Ast } from 'thingtalk';
import * as Tp from 'thingpedia';
interface AutoCanonicalGeneratorOptions {
    dataset: 'schemaorg' | 'sgd' | 'multiwoz' | 'wikidata' | 'custom';
    paraphraser_model: string;
    remove_existing_canonicals: boolean;
    type_based_projection: boolean;
    max_per_pos?: number;
    batch_size: number;
    filtering: boolean;
    debug: boolean;
}
export default class AutoCanonicalGenerator {
    private class;
    private entities;
    private constants;
    private functions;
    private paraphraserModel;
    private annotatedProperties;
    private langPack;
    private options;
    private entityNames;
    private childEntities;
    constructor(classDef: Ast.ClassDef, entities: Tp.BaseClient.EntityTypeRecord[], constants: Record<string, any[]>, functions: string[], options: AutoCanonicalGeneratorOptions);
    generate(): Promise<Ast.ClassDef>;
    private _loadManualCanonicalOverride;
    private _generateBaseCanonicalAnnotation;
    private _addProjectionCanonicals;
    private _processProjectionCanonical;
    private _retrieveSamples;
    private _trimAnnotations;
}
export {};
